viMouseKeyEvents = {};

function viMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)	
	if not VehicleInspector.global.isOn and unicode ~= nil then viMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, true); return;end;
	if unicode ~= nil then
		if not g_currentMission.hl.dragDrop.on then
			viMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false);			
		end;
	else
		if g_currentMission.hl.isMouseCursor then
			if not g_currentMission.hl.dragDrop.on then
				viMouseKeyEvents:setMouse(posX, posY, isDown, isUp, button);
			elseif g_currentMission.hl.dragDrop.on then
				
			end;
		end;
	end;	
end;

function viMouseKeyEvents:setMouse(posX, posY, isDown, isUp, button)
	local isPreviewArea = false;
	if VehicleInspector.global.isOn and not VehicleInspector.global.onlyMoh then
		for key,value in pairs (VehicleInspector.clickAreas.master) do
			if value ~= nil and value[1] ~= nil then
				if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then	
					local whichArea = value.whichArea;
					if whichArea == "default" and VehicleInspector.clickAreas.slave[whichArea] ~= nil and #VehicleInspector.clickAreas.slave[whichArea] > 0 then
						for area=1, #VehicleInspector.clickAreas.slave[tostring(whichArea)] do
							if VehicleInspector.clickAreas.slave[tostring(whichArea)][area] ~= nil then
								if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(VehicleInspector.clickAreas.slave[tostring(whichArea)][area]))then
									local clickAreaTable = VehicleInspector.clickAreas.slave[tostring(whichArea)][area];
									if button == Input.MOUSE_BUTTON_LEFT and isDown and (tostring(clickAreaTable.whereClick) == "vehicleJoin_") then
										viSetGet:clickVehicleJoin(clickAreaTable);
										break;										
									elseif (tostring(clickAreaTable.whereClick) == "vehicleJoin_") then
										if VehicleInspector.global.previewVehicleData.isOn then											
											VehicleInspector.previewVehicleData[1] = clickAreaTable;
											isPreviewArea = true;											
										end;
									end;
								end;
							end;
						end;
					elseif whichArea == "setting" and VehicleInspector.clickAreas.slave[whichArea] ~= nil and #VehicleInspector.clickAreas.slave[whichArea] > 0 then
						for area=1, #VehicleInspector.clickAreas.slave[tostring(whichArea)] do
							if VehicleInspector.clickAreas.slave[tostring(whichArea)][area] ~= nil then
								if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(VehicleInspector.clickAreas.slave[tostring(whichArea)][area]))then
									if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(VehicleInspector.clickAreas.slave[tostring(whichArea)][area]))then
										local clickAreaTable = VehicleInspector.clickAreas.slave[tostring(whichArea)][area];
										if button == Input.MOUSE_BUTTON_LEFT and isDown then
											if tostring(clickAreaTable.whereClick) == "viewHidden_" then
												VehicleInspector.global.isHidden = not VehicleInspector.global.isHidden;
												break;
											elseif tostring(clickAreaTable.whereClick) == "viewSortByCategory_" then												
												if VehicleInspector.global.sortBy+1 > VehicleInspector.vehicleTypeCategoryNumber.max then
													VehicleInspector.global.sortBy = 0;
												else													
													for sort=VehicleInspector.global.sortBy+1, VehicleInspector.vehicleTypeCategoryNumber.max do														
														if VehicleInspector.vehicleTypeCategoryName[sort] ~= nil then
															if VehicleInspector.vehicleTypeCategoryViewSettingLine[VehicleInspector.vehicleTypeCategoryName[sort]] ~= nil then
																VehicleInspector.global.sortBy = sort;
																break;
															end;
														end;														
													end;																										
												end;												
												if VehicleInspector.global.sortBy == 0 then
													g_currentMission.hl.addTextDisplay( {txt="Set Vehicle... NOT SORT", txtBold=true, duration=3} );													
												else
													g_currentMission.hl.addTextDisplay( {txt="Set Category *".. tostring(VehicleInspector.vehicleTypeCategoryViewSettingLine[VehicleInspector.vehicleTypeCategoryName[VehicleInspector.global.sortBy]][3]).. "* onTop", txtBold=true, duration=3} );													
												end;
												break;
											elseif tostring(clickAreaTable.whereClick) == "viewForce_" then
												if VehicleInspector.global.forceView+1 > 2 then VehicleInspector.global.forceView = 0;else VehicleInspector.global.forceView = VehicleInspector.global.forceView+1;end;		
												g_currentMission.hl.addTextDisplay( {txt="Set ViewForce *".. tostring(VehicleInspector.global.forceView).."* (default 0)", txtBold=true, duration=3} );												
												break;
											elseif not string.find(tostring(clickAreaTable.whereClick), "view") then
												local whereClick = string.gsub(tostring(clickAreaTable.whereClick), "_", "");
												if VehicleInspector.seeVehicle[whereClick] ~= nil then VehicleInspector.seeVehicle[whereClick] = not VehicleInspector.seeVehicle[whereClick];end;
												--old value
												if whereClick == "train" then VehicleInspector.seeVehicle.isTrain = VehicleInspector.seeVehicle.train;end; --old and new boolean
												--old value
												if VehicleInspector.seeVehicle[whereClick] then
													g_currentMission.hl.addTextDisplay( {txt="View Vehicle *".. tostring(whereClick).. "*", txtBold=true, duration=3} );													
												else
													g_currentMission.hl.addTextDisplay( {txt="View NOT Vehicle *".. tostring(whereClick).. "*", txtBold=true, duration=3} );													
												end;
												break;
											end;
										elseif button == Input.MOUSE_BUTTON_RIGHT and isDown then
											if tostring(clickAreaTable.whereClick) == "viewHidden_" then
												viSetGet:openCloseGuiMenue();
												break;											
											elseif tostring(clickAreaTable.whereClick) == "viewSortByCategory_" then												
												if VehicleInspector.global.sortBy-1 < 0 then													
													VehicleInspector.global.sortBy = VehicleInspector.vehicleTypeCategoryNumber.max;
												else
													local sort = VehicleInspector.global.sortBy-1;
													while sort >= 0 do
														if sort == 0 then VehicleInspector.global.sortBy = 0;break;end;
														if VehicleInspector.vehicleTypeCategoryName[sort] ~= nil then
															if VehicleInspector.vehicleTypeCategoryViewSettingLine[VehicleInspector.vehicleTypeCategoryName[sort]] ~= nil then
																VehicleInspector.global.sortBy = sort;
																break;
															end;
														end;
														sort = sort-1;
													end;																								
												end;												
												if VehicleInspector.global.sortBy == 0 then
													g_currentMission.hl.addTextDisplay( {txt="Set Vehicle... NOT SORT", txtBold=true, duration=3} );													
												else
													g_currentMission.hl.addTextDisplay( {txt="Set Category *".. tostring(VehicleInspector.vehicleTypeCategoryViewSettingLine[VehicleInspector.vehicleTypeCategoryName[VehicleInspector.global.sortBy]][3]).. "* onTop", txtBold=true, duration=3} );
												end;
												break;											
											elseif tostring(clickAreaTable.whereClick) == "viewForce_" then
												if VehicleInspector.global.forceView-1 < 0 then VehicleInspector.global.forceView = 2;else VehicleInspector.global.forceView = VehicleInspector.global.forceView-1;end;		
												g_currentMission.hl.addTextDisplay( {txt="Set ViewForce *".. tostring(VehicleInspector.global.forceView).."* (default 0)", txtBold=true, duration=3} );
												break;
											elseif tostring(clickAreaTable.whereClick) == "isGroup_" then
												if not VehicleInspector.global.foundMoh or not VehicleInspector.global.groupLine.mohSlot then
													viSetGet:openCloseGuiMenue("GroupManagerSetting", "GroupManagerSetting");
												else
													if g_currentMission.multiOverlayV4.slotFunction.getSlotTable("viVehicleGroupsSlot_") == nil then
														viSetGetForMoh:generateVehicleInspectorGroupsSlot();
													else
														g_currentMission.multiOverlayV4.moSetGetOverlays.slot["viVehicleGroupsSlot_"].isOpen = not g_currentMission.multiOverlayV4.moSetGetOverlays.slot["viVehicleGroupsSlot_"].isOpen;														
													end;
												end;
												break;
											end;
										end;
									end;
								end;
							end;	
						end;		
					elseif whichArea == "groupLine" and VehicleInspector.clickAreas.slave[whichArea] ~= nil and #VehicleInspector.clickAreas.slave[whichArea] > 0 then
						for area=1, #VehicleInspector.clickAreas.slave[tostring(whichArea)] do
							if VehicleInspector.clickAreas.slave[tostring(whichArea)][area] ~= nil then
								if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(VehicleInspector.clickAreas.slave[tostring(whichArea)][area]))then
									if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(VehicleInspector.clickAreas.slave[tostring(whichArea)][area]))then
										local clickAreaTable = VehicleInspector.clickAreas.slave[tostring(whichArea)][area];
										if button == Input.MOUSE_BUTTON_LEFT and isDown then
											if tostring(clickAreaTable.whereClick) == "group_" then
												VehicleInspector.seeVehicle.isGroup = not VehicleInspector.seeVehicle.isGroup;
												g_currentMission.hlGui.setGet:setUnSave();
												if VehicleInspector.seeVehicle.isGroup then
													g_currentMission.hl.addTextDisplay( {txt="View Vehicle *isGroup*", txtBold=true, duration=3} );													
												else
													g_currentMission.hl.addTextDisplay( {txt="View NOT Vehicle *isGroup*", txtBold=true, duration=3} );													
												end;
												
												
												--local moreTxt = "Open MOH Group Slot with MouseClick Right on G\nView a Group with MouseClick Left --> Group Number\nInsert-Delete Vehicle in Group with MouseClick Right ---> Group Number";
												--local maxLine = 4;												
												--g_currentMission.hl.addTextDisplay( {txt="Vehicle GroupManager INFO\n".. tostring(moreTxt), maxLine=maxLine, txtBold=true, duration=4} );												
												break;
											elseif tostring(clickAreaTable.whereClick) == "viewGroup_" then
												viGroupManager:setViewGroup(clickAreaTable.group);
												if viGroupManager:isViewGroup(clickAreaTable.group) and not viGroupManager:hasGroupVehicles(clickAreaTable.group) then
													g_currentMission.hl.addTextDisplay( {txt="GroupManager: ".. tostring(viGroupManager.groupsName[clickAreaTable.group]).. " ! is empty !", txtBold=true, warning=true, duration=3} );
												else
													if viGroupManager.viewGroups[clickAreaTable.group] then
														g_currentMission.hl.addTextDisplay( {txt="View Group: ".. tostring(viGroupManager.groupsName[clickAreaTable.group]), txtBold=true, duration=3} );
													else
														g_currentMission.hl.addTextDisplay( {txt="NOT View Group: ".. tostring(viGroupManager.groupsName[clickAreaTable.group]), txtBold=true, duration=3} );
													end;
												end;
												break;
											elseif tostring(clickAreaTable.whereClick) == "saveGroups_" then
												g_currentMission.hl.addTextDisplay( {txt="GroupManager: save Group Profil... (".. tostring(viGroupManager:getActiveProfil()).. ".xml)", txtBold=true, duration=3} );
												viGroupManagerXml:saveProfile(true);
												break;
											end;
										elseif button == Input.MOUSE_BUTTON_RIGHT and isDown then
											if tostring(clickAreaTable.whereClick) == "group_" then
												if not VehicleInspector.global.foundMoh or not VehicleInspector.global.groupLine.mohSlot then
													viSetGet:openCloseGuiMenue("GroupManagerSetting", "GroupManagerSetting");
												else
													if g_currentMission.multiOverlayV4.slotFunction.getSlotTable("viVehicleGroupsSlot_") == nil then
														viSetGetForMoh:generateVehicleInspectorGroupsSlot();
													else
														g_currentMission.multiOverlayV4.moSetGetOverlays.slot["viVehicleGroupsSlot_"].isOpen = not g_currentMission.multiOverlayV4.moSetGetOverlays.slot["viVehicleGroupsSlot_"].isOpen;														
													end;
												end;
												break;
											elseif tostring(clickAreaTable.whereClick) == "viewGroup_" then
												if g_currentMission.controlledVehicle ~= nil then --and not VehicleInspector.global.groupLine.setting then
													viGroupManager:insertGroupVehicle(g_currentMission.controlledVehicle, clickAreaTable.group, true);
												else
													g_currentMission.hl.addTextDisplay( {txt="GroupManager: ! Join first a Vehicle !", txtBold=true, warning=true, duration=4} );
												end;
												break;
											end;											
										end;
									end;
								end;
							end;
						end;
					end;
				end;
			end;
		end;
	end;
	if not isPreviewArea and VehicleInspector.previewVehicleData[1] ~= nil then VehicleInspector.previewVehicleData[1] = nil;end;
end;

function viMouseKeyEvents:setKey(unicode, sym, modifier, isDown, onlyMouse, cursorOnOff, action)
	--InputAction	
	if cursorOnOff then
		if g_currentMission.hl.isMouseCursor then
			VehicleInspector:get_hl("mouseOnOff", {false,false,"VehicleInspector"}, "viMouseKeyEvents:setKey");			
		else
			VehicleInspector:get_hl("mouseOnOff", {true,g_currentMission.hlGui.menue.playerFrozen,"VehicleInspector"}, "viMouseKeyEvents:setKey");			
		end;			
		return;	
	end;
	if action ~= nil and action == "VIViewContractorVehicle" then		
		VehicleInspector.seeVehicle.isOwnFarmVehicle = not VehicleInspector.seeVehicle.isOwnFarmVehicle;		
		if VehicleInspector.seeVehicle.isOwnFarmVehicle then
			g_currentMission.hl.addTextDisplay( {txt="Set ViewContractor Vehicle *OFF*", txtBold=true, duration=3} );			
		else
			g_currentMission.hl.addTextDisplay( {txt="Set ViewContractor Vehicle *ON*", txtBold=true, duration=3} );			
		end;
		return;
	end;
	if action ~= nil and action == "VIViewForce" then		
		if VehicleInspector.global.forceView+1 > 2 then VehicleInspector.global.forceView = 0;else VehicleInspector.global.forceView = VehicleInspector.global.forceView+1;end;		
		g_currentMission.hl.addTextDisplay( {txt="Set ViewForce *".. tostring(VehicleInspector.global.forceView).."* (default 0)", txtBold=true, duration=3} );
		return;
	end;
	if action ~= nil and action == "VIMarkedVehicle" then		
		viSetGetForMoh:markedVehicle();		
		return;
	end;	
	if action ~= nil and action == "VIJoinMarkedVehicle" then	
		viSetGetForMoh:joinVehicle(1, "marked", true, "all")
	end;
	if Input.isKeyPressed(Input.KEY_f2)then --VehicleInspector.hlDebugMode and Input.isKeyPressed(Input.KEY_f2)
		--if g_screenshotsDirectory ~= nil then
		--	local screenshotName = g_screenshotsDirectory .. "fsScreen_" .. getDate("%Y_%m_%d_%H_%M_%S") .. ".jpg"
		--	saveScreenshot(screenshotName)
		--else
		--	print("Unable to find screenshot directory!")
		--end
		--viGroupManager:printGroup(1)
		--viGroupManager:printVehicleGroups();
		--print(DebugUtil.printTableRecursively(MissionManager.mission.field, "MissionManager.mission.field ", 0, 2))		
		--g_currentMission.hl.debugPrint("VehicleInspectorMod");
		--local vehicle = g_currentMission.controlledVehicle;
		--if vehicle ~= nil then
		--	print("---------------")
		--	print(DebugUtil.printTableRecursively(vehicle, "controlled vehicle ", 0, 2))
		--	local missionsList = g_missionManager:getMissionsList( g_currentMission.player.farmId);
		--	print("---------------")
		--	print(DebugUtil.printTableRecursively(missionsList, "missionsList ", 0, 2))
		--end;		
	end;
end;